﻿using Mysqlx.Crud;
using StudentManager.Common;
using StudentManager.Data;
using StudentManager.Extensions;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace StudentManager.Model
{
	class MenuBar : BindableBase
	{
		private string icon;
		/// <summary>
		/// Icon
		/// </summary>
		public string Icon
		{
			get { return icon; }
			set { icon = value; }
		}

		private string title;

		public string Title
		{
			get { return title; }
			set { title = value; }
		}


		private string nameSpace;

		public string NameSpace
		{
			get { return nameSpace; }
			set { nameSpace = value; }
		}


	}

	class Students : BindableBase
	{

		private ObservableCollection<StudentData> studentDatas = new ObservableCollection<StudentData>();
		public ReadOnlyObservableCollection<StudentData> StudentDatas { get; private set; }

		private ObservableCollection<QuestionData> questionDatas = new ObservableCollection<QuestionData>();
		public ReadOnlyObservableCollection<QuestionData> QuestionDatas { get; private set; }

		private ObservableCollection<MenuBar> menuBars = new ObservableCollection<MenuBar>();
		public ReadOnlyObservableCollection<MenuBar> MenuBars { get; private set; }

		private readonly IRegionManager regionManager;

		public DelegateCommand<string> RegionTo { get; set; }

		Students(IRegionManager regionManager)
		{
			CreateMenuBar();

			RegionTo = new DelegateCommand<string>((x) => {
				regionManager.Regions[PrismManager.MainRegionName].RequestNavigate(x.ToString()); 
				RegionToStudents(); 
			});


			StudentDatas = new ReadOnlyObservableCollection<StudentData>(studentDatas);
			QuestionDatas = new ReadOnlyObservableCollection<QuestionData>(questionDatas);
			MenuBars = new ReadOnlyObservableCollection<MenuBar>(menuBars);





			this.regionManager = regionManager;

			QueryAll();
			
			Query();
		}

		private void RegionToStudents()
		{
			
		}

		void CreateMenuBar()
		{
			menuBars.Add(new MenuBar() { Icon = "ForumPlusOutline", Title = "学生", NameSpace = "StudentsView" });
			menuBars.Add(new MenuBar() { Icon = "CodeGreaterThanOrEqual", Title = "题库", NameSpace = "QuestionsView" });
		}


		private void QueryAll()
		{
			studentDatas.Clear();
			questionDatas.Clear();
			SQLHelper.Query<StudentData>(Tables.UserTable).ForEach(x => studentDatas.Add(x));
			SQLHelper.Query<QuestionData>(Tables.QuesTable).ForEach(x => questionDatas.Add(x));
			//SQLHelper.UnionQuery<QuestionData>(1).ForEach(x => questionDatas.Add(x)); 
		}
	}
}
